#set term postscript landscape
set term postscript eps
set output 'moving.ps'
#set size 1.5,1.5
set border
set tics out
#set key 350,250
#set noxtics
#set noytics
#set noxzeroaxis
#set noyzeroaxis
#set arrow from 0,0 to 0,1100 
#set arrow from 0,0 to 0,400 nohead
set data style lines
#set arrow from 0,0 to 0,1100
#set arrow from 0,0 to 400,0 nohead
set noparametric
set hidden3d
set nokey
set ytics ("far apart" 0, "overlap" 16, "even" 24, "overlap" 32, "far apart" 49)
set ticslevel 0
set zrange [0:500]
set xrange [0:100]
#uncomment this to get the side view
#set view ,78
set xtics 0, 10, 110
set xlabel "Plausibility"
set ylabel "Relative Position" ,-2
set zlabel "Microseconds", -1 
splot "move" title "isobar"
