/***********************************************************************\ 
*                                                                       * 
*   File: calendric_system/newh/ucs/external.h
*                                                                       * 
*   The MultiCal System is free software in the public domain; you can  * 
*   redistribute it and/or modify it as you wish. We ask that you       * 
*   retain credits referencing the University of Arizona and that you   * 
*   identify any changes you make.                                      * 
*                                                                       * 
*   Report problems to multical@cs.arizona.edu                          * 
*   Direct all inquiries to:    The MultiCal Project                    * 
*                               Department of Computer Science          * 
*                               University of Arizona                   * 
*                               Tucson, AZ 85721                        * 
*                               U.S.A.                                  * 
*                                                                       * 
\***********************************************************************/ 
#ifndef ucs_external
#define ucs_external

typedef enum { fixed, variable, unknown } span_types;

typedef struct {
    span_types tag;
    avg_state_fs fs_state;
    void *vs_state;
} ucs_avg_state_s;

typedef struct {
    span_types tag;
    span_type fs_state;
    void *vs_state;
} ucs_sum_state_s;

typedef struct {
    span_types tag;
    span_type fs_state;
    void *vs_state;
} ucs_min_state_s;

typedef struct {
    span_types tag;
    span_type fs_state;
    void *vs_state;
} ucs_max_state_s;

#endif
