/***********************************************************************\ 
*                                                                       * 
*   File: calendric_system/newh/ucs.h
*                                                                       * 
*   The MultiCal System is free software in the public domain; you can  * 
*   redistribute it and/or modify it as you wish. We ask that you       * 
*   retain credits referencing the University of Arizona and that you   * 
*   identify any changes you make.                                      * 
*                                                                       * 
*   Report problems to multical@cs.arizona.edu                          * 
*   Direct all inquiries to:    The MultiCal Project                    * 
*                               Department of Computer Science          * 
*                               University of Arizona                   * 
*                               Tucson, AZ 85721                        * 
*                               U.S.A.                                  * 
*                                                                       * 
\***********************************************************************/ 
#include "ucs/field_names.h"
#include "ucs/error.h"
#include "ucs/external.h"
#include "ucs/arithmetic.h"
#include "ucs/binding.h"
#include "ucs/calendric.h"
#include "ucs/comparison.h"
#include "ucs/input.h"
#include "ucs/output.h"
#include "ucs/property_ext.h"
#include "ucs/property.h"
#include "ucs/init.h"
#include "ucs/value_array.h"
#include "ucs/aggregate.h"
#include "ucs/property_internal.h"
#include "ucs/multiplex.h"
#include "ucs/internal.h"
#include "ucs/global.h"
#include "ucs/allocation.h"


